library account;

import 'account_web.dart' if (dart.library.io) "account_native.dart"
    as account_impl;

abstract class Account {
  const factory Account() = account_impl.Account;

  Future<int> getLoginStatus();
  Future<int> login(LoginTicketInfo info);
  Future<bool> isLogin();
  Future<void> logout();
  Future<int> cancelLogin();

  Future<Map<dynamic, dynamic>> getPhoneCheckCode(String phone);
  Future<Map<dynamic, dynamic>> loginWithPhone(String phone, String checkCode);

  Future<Map<dynamic, dynamic>> getLoginInfo();
  Future<String> getUid();
  Future<String> getA2();
}

class LoginTicketInfo {
  int loginType;
}

final Account account = Account();
