import 'package:account/account_errcode.dart';

import 'account.dart';
import 'cookies.dart';
import 'dart:html';
import 'dart:js' as js;

import 'account.dart' as base_account;

class Account implements base_account.Account {
  const Account();

  @override
  Future<String> getA2() async{
    var cookies = getCookie();
    String a2 = cookies['ilive_a2'];
    return a2;
  }

  @override
  Future<String> getUid() async {
    var cookies = getCookie();
    return cookies['ilive_uin'];
  }

  @override
  Future<bool> isLogin() async{
    var cookies = getCookie();
    String a2 = cookies['ilive_a2'];
    String uin = cookies['ilive_uin'];
    print("a2: $a2, uin: $uin");
    return a2 != null && uin != null && a2.isNotEmpty && uin.isNotEmpty;
  }

  @override
  Future<int> login(LoginTicketInfo info) async {
    bool isLogined = await isLogin();
    if (isLogined) {
      return AccountErrcode.Success;
    }
    await _login();
  }

  @override
  Future<void> logout() {
    clearCookies();
  }

  void _login() {
    var callbackUrl = Uri.encodeFull(document.window.location.toString());
    final loginUrl =
        "https://tencentlive.qq.com/shopwindow/#/login?redirectUrl=" +
            "$callbackUrl";
    js.context.callMethod("gotoPage", [loginUrl]);
  }

  @override
  Future<Map> getLoginInfo() {
    // TODO: implement getLoginInfo
    return null;
  }

  @override
  Future<int> getLoginStatus() {
    // TODO: implement getLoginStatus
    return null;
  }

  @override
  Future<Map> getPhoneCheckCode(String phone) {
    // TODO: implement getPhoneCheckCode
    return null;
  }

  @override
  Future<Map> loginWithPhone(String phone, String checkCode) {
    // TODO: implement loginWithPhone
    return null;
  }

  @override
  Future<int> cancelLogin() {
    // TODO: implement cancelLogin
    return null;
  }
}

String getUid() {
  var cookies = getCookie();
  return cookies['ilive_uin'];
}

String getA2() {
  var cookies = getCookie();
  String a2 = cookies['ilive_a2'];
  return a2;
}
